	program borehole
	common /tables/t0,p0,dtherm,dpress,tabd(51,51),tabv(51,51)
	common /matr/ap,an,ae,aw,as
	common /mesh/nx,ny,nxy/right/b/solver/niter
	common /waste/act,ree,timestor,numrad,numwell,
	*cl1,cl2,f0,rkappa,rhom,wmass(4,41)
	common /debug/ itbcong
	character*2 symb
	character*7 tgrd,cgrd,wgrd
	character*11 velocity,pressure
	character*14 tprofile
	dimension rxgrd(101),rygrd(101),igrid(101),jgrid(101)
	real x(101),y(101)
	real vx(101,101,41),vy(101,101,41),vz(101,101,41)
	real t(101,101,41),p(101,101,41),p1(101,101,41),pxy(101,101)
	real*8 s(10201)
	real*8 ap(10201),an(10201),ae(10201),aw(10201),as(10201),b(10201)
	real*8 diffz,difft
	real*8 alx,bex,gax,aly,bey,gay,alz,bez,gaz
	real nc,nc1,nlam,nlamc,line(101),kd
	real wa(101,101,41)
	real w(101,101,41),ux(101,101,41),uy(101,101,41),uz(101,101,41)
	real dispx(101,101,41),dispy(101,101,41),dispz(101,101,41)
	real rho(101,101,41),mu(101,101,41),nu(101,101,41)
	real t1(101,101,41),t2(101,101,41),t3(101,101,41)
	real pbas(41),tbas(41),rgbas(41)
	real womega(101,101),tout(21)
	real*8 al(101),be(101),ga(101),ww(101)
	integer wcoord(2,9),wnum(101,101)
	data patm/1.e5/,g/9.8/,rel/0.0005/,eps1/1.e-7/
	data cf/4200./
	data tgrd/'t  .grd'/,cgrd/'c  .grd'/,wgrd/'w  .grd'/,
	*tprofile/'tprofile  .dat'/,pressure/'press  .grd'/,
     *velocity/'veloc  .dat'/

	data w0/0.1/
	data witer/0.99/,intw/20/

	witer1=1.-witer
	w1=1.-w0

	open (1,file='Initdat')
	open (2,file='time.dat')



	read (1,*) rw,depth,dzl
	read (1,*) deltax,xlim,nx
	read (1,*) deltay,ylim,ny
	read (1,*) zlim,nz
	read (1,*) tatm,geotherm
	read (1,*) perm,phi,cond,rhor,cr
	read (1,*) act,ree,rhom,timestor,cplu
c fractions by weight of REE and actinides, waste form density, temporary storage time,
c                      length of canisters per well length unit
	read (1,*) alpha
	read (1,*) kd,diffmol
	read (1,*) numrad,clim
	read (1,*) niter,eps
	read (1,*) nout,(tout(i),i=1,nout)
	phi1=1.-phi
	alphae=alpha/phi
	xi=1.+(1.-phi)/phi*rhor*kd
	rhocr=rhor*cr
	nz1=nz-1
	dz=zlim/nz1
	dz2=dz*dz
	nzb=(zlim-depth)/dz+1
	nzt=(zlim-depth+dzl)/dz+1
	nzm=(nzt+nzb)/2
	nx1=nx-1
	ny1=ny-1
	nxy=nx*ny
	m=(nx-9)/2+1
	i1=m/2
	m1=2*i1
	m1=max0(m1,2)
	i1=m1/2
	m2=nx-7-m1
	if(m2.lt.2) then
	write (*,*) 'Minor nx'
	write (*,*) 'Press <ENTER> to finish'
	read (*,*) 
	stop
	end if
	step0=rw/2.
	call root(i1,deltax/rw-2., gx1)
	step=step0
	do i=1,3
	x(i)=step*(i-1)
	end do
	do i=4,i1+3
	x(i)=x(i-1)+step
	step=step*gx1
	end do
	step=step0
	i2=m1+5
	do i=1,3
	x(i2+1-i)=deltax-step*(i-1)
	end do
	do i=4,i1+2
	x(i2+1-i)=x(i2+2-i)-step
	step=step*gx1
	end do
	call root(m2,(xlim-deltax-rw)/step0,gx2)
	do i=1,2
	x(i2+i)=deltax+step0*i
	end do
	step=step0
	do i=1,m2
	ii=i2+i+2
	x(ii)=x(ii-1)+step
	step=step*gx2
	end do
	mx=m+1 ! m is a number of intervals, m+1 is a number of nodes
	m=(ny-9)/2+1
	i1=m/2
	m1=2*i1
	m1=max0(m1,2)
	i1=m1/2
	m2=ny-7-m1
	if(m2.lt.2) then
	write (*,*) 'Minor ny'
	write (*,*) 'Press <ENTER> to finish'
	read (*,*) 
	stop
	end if
	step0=rw/2.
	call root(i1,deltay/rw-2., gy1)
	step=step0
	do j=1,3
	y(j)=step*(j-1)
	end do
	do j=4,i1+3
	y(j)=y(j-1)+step
	step=step*gy1
	end do
	step=step0
	i2=m1+5
	do j=1,3
	y(i2+1-j)=deltay-step*(j-1)
	end do
	do j=4,i1+2
	y(i2+1-j)=y(i2+2-j)-step
	step=step*gy1
	end do
	call root(m2,(ylim-deltay-rw)/step0,gy2)
	do j=1,2
	y(i2+j)=deltay+step0*j
	end do
	step=step0
	do j=1,m2
	ii=i2+j+2
	y(ii)=y(ii-1)+step
	step=step*gy2
	end do
	my=m+1 ! m is a number of intervals, m+1 is a number of nodes

c
c                        grid xy is determined
c
	do i=1,2
	do j=1,2
	nwell=(j-1)*2+i
	i1=(mx+2)*(i-1)+1
	j1=(my+2)*(j-1)+1
	wcoord(1,nwell)=i1
	wcoord(2,nwell)=j1
	end do
	end do
	xm=x(mx+3)
	ym=y(my+3)
	rw2=rw*rw
	dxi0=x(2)/20.
	dyi0=y(2)/20.
	do i=1,nx1
	do j=1,ny1
	if(i.eq.1) then
	x0i=0.
	dxi=dxi0
	else
	x0i=(x(i)+x(i-1))/2.
	dxi=(x(i+1)-x(i-1))/20.
	end if
	if(j.eq.1) then
	y0i=0.
	dyi=dyi0
	else
	y0i=(y(j-1)+y(j))/2.
	dyi=(y(j+1)-y(j-1))/20.
	end if
	sum=0.
	wnum(i,j)=0
	do i1=1,10
	do j1=1,10
	xci=x0i+dxi*(i1-0.5)
	yci=y0i+dyi*(j1-0.5)
	do nwell=1,4
	i2=wcoord(1,nwell)
	j2=wcoord(2,nwell)
	dist=(xci-x(i2))**2+(yci-y(j2))**2
	if(dist.le.rw2) then
	sum=sum+1.
	wnum(i,j)=nwell
	end if
	end do ! nwell
	end do ! j1
	end do ! i1	
	womega(i,j)=sum/100.
	end do ! j
	end do ! i

	nwxgrid=xm/xlim*100.
	dxgrd=xm/nwxgrid
	xlimgrid=dxgrd*100.
	nwygrid=ym/ylim*100.
	dygrd=ym/nwygrid
	ylimgrid=dygrd*100.
	do i=1,101
	xc=dxgrd*(i-1)
	do i1=1,nx1
	if(x(i1).le.xc.and.x(i1+1).ge.xc) go to 10
	end do
	i1=nx1
10	igrid(i)=i1
	rxgrd(i)=(xc-x(i1))/(x(i1+1)-x(i1))
	end do ! i
	do j=1,101
	yc=dygrd*(j-1)
	do j1=1,ny1
	if(y(j1).le.yc.and.y(j1+1).ge.yc) go to 20
	end do
	j1=ny1
20	jgrid(j)=j1
	rygrd(j)=(yc-y(j1))/(y(j1+1)-y(j1))
	end do ! j



	tmin=tatm
	rlim=sqrt(xlim**2+ylim**2)
	call heat_gen(0.,omega)
	tmax1=tatm+geotherm*zlim
	tmax2=tatm+geotherm*depth+omega*rw**2/2./cond*alog(rlim/rw)
 	tmax=amax1(tmax1,tmax2)
	tmax=300.
	write (*,*) 'T_max: ',tmax
	write (*,*)
	pmin=patm
	pmax=pmin+1.e4*zlim+10.

	call tabgener(tmin,tmax,pmin,pmax)

	tbas(nz)=tatm
	pbas(nz)=patm
	cff1=geotherm*dz
	cff2=g*dz
	do k1=1,nz1
	k=nz-k1
	tbas(k)=tbas(k+1)+cff1
	call prop(pbas(k+1),tbas(k+1),rgbas(k+1),'dens')
	pbas(k)=pbas(k+1)+cff2*rgbas(k+1)
	end do ! k1
	call prop(pbas(1),tbas(1),rgbas(1),'dens')
	do k=1,nz
	do i=1,nx
	do j=1,ny
	t(i,j,k)=tbas(k)
	rho(i,j,k)=rgbas(k)
	p(i,j,k)=0.
	w(i,j,k)=0.
	end do
	end do
	end do
	wellload=3.14*rw**2*rhom*cplu
	do nwell=1,4
	do k=1,nz
	if(k.lt.nzb.or.k.gt.nzt) then
	wmass(nwell,k)=0.
	else
	wmass(nwell,k)=wellload
	end if
	end do ! k
	end do ! nwell


	cl1=6.28*rw*cplu
	cl2=2.*cplu/phi/xi/clim/rw

	time=0.
	dtyear=1.
	dtyear1=dtyear/intw
	dt=dtyear*3.15e7
	dt1=dtyear1*3.15e7
c	end of initial conditions

c********************************  START  *************************************************

	open (3,file='temper.dat')

	do iout=1,nout
	if(iout.eq.1) then
	nt=tout(1)/dtyear
	else
	nt=(tout(iout)-tout(iout-1))/dtyear
	nt=max0(nt,1)
	end if
	do ntime=1,nt
	anu=0.
	anu1=1.e10
	do i=1,nx
	do j=1,ny
	diffp=0.
	do k1=1,nz
	k=nz+1-k1
	pc=p(i,j,k)+pbas(k)
	tc=t(i,j,k)
	call prop(pc,tc,rho(i,j,k),'dens')
	call prop(pc,tc,mu(i,j,k),'visc')
	nu(i,j,k)=mu(i,j,k)/rho(i,j,k)
	anu=amax1(anu,nu(i,j,k))
	anu1=amin1(anu1,nu(i,j,k))
	end do
	end do
	end do
	do i=1,nx
	do j=1,ny
	do k=1,nz
	nu(i,j,k)=nu(i,j,k)/anu
	end do
	end do
	end do
	ds=dz2/2.*rel
	if((ntime-1)/5*5.ne.ntime-1) go to 100
	iter=1
1	continue
	delp=0.
	acf1=2.*ds
	acf2=2.*ds/dz2
	acf3=g*ds/2./dz
	do i=1,nx
	do j=1,ny
	pxy(i,j)=0.
	end do
	end do
	pxy(1,1)=1.e2
	pxy(mx+3,1)=1.e2
	pxy(1,my+3)=1.e2
	pmax=0.
	do i=1,nx
	do j=1,ny
	do k=1,nz
	pmax=amax1(pmax,abs(p(i,j,k)))
	end do
	end do
	end do
	do k=2,nz1
	do i=1,nx1
	do j=1,ny1
	n=(j-1)*nx+i
	if(i.eq.1) then
	ae(n)=-acf1/(nu(i,j,k)+nu(i+1,j,k))/(x(2)-x(1))**2
	aw(n)=0.
	else
	ae(n)=-acf1/(nu(i,j,k)+nu(i+1,j,k))/(x(i+1)-x(i-1))/
     /(x(i+1)-x(i))
	aw(n)=-acf1/(nu(i,j,k)+nu(i-1,j,k))/(x(i+1)-x(i-1))/
	/(x(i)-x(i-1))
	end if
	if(j.eq.1) then
	an(n)=-acf1/(nu(i,j,k)+nu(i,j+1,k))/(y(2)-y(1))**2
	as(n)=0.
	else
	an(n)=-acf1/(nu(i,j,k)+nu(i,j+1,k))/(y(j+1)-y(j-1))/
	/(y(j+1)-y(j))
	as(n)=-acf1/(nu(i,j,k)+nu(i,j-1,k))/(y(j+1)-y(j-1))/
	/(y(j)-y(j-1))
	end if
	ap(n)=1.-an(n)-ae(n)-aw(n)-as(n)
	diffz=acf2*((p(i,j,k+1)-p(i,j,k))/(nu(i,j,k)+nu(i,j,k+1))-
	-(p(i,j,k)-p(i,j,k-1))/(nu(i,j,k)+nu(i,j,k-1)))
	difft=acf3*((rho(i,j,k+1)-rgbas(k+1))/nu(i,j,k+1)-
     -(rho(i,j,k-1)-rgbas(k-1))/nu(i,j,k-1))
	b(n)=(2.-ap(n))*p(i,j,k)-an(n)*p(i,j+1,k)-as(n)*p(i,j-1,k)-
     -ae(n)*p(i+1,j,k)-aw(n)*p(i-1,j,k)+diffz+difft
	pxy(i,j)=p(i,j,k)
	end do ! j
	end do ! i
	j1=ny1*nx
	do i=1,nx
	n=j1+i
	ap(n)=1.
	an(n)=0.
	as(n)=0.
	ae(n)=0.
	aw(n)=0.
	b(n)=0.
	end do
	do j=1,nx
	n=j*nx
	ap(n)=1.
	an(n)=0.
	as(n)=0.
	ae(n)=0.
	aw(n)=0.
	b(n)=0.
	end do

c***************************************************************
	call bcong(s,pxy,eps1)
	do j=1,ny
	j1=nx*(j-1)
	do i=1,nx
	cont=0.
	n=j1+i
	p1(i,j,k)=s(n)
	pxy(i,j)=s(n)
	end do
	end do
	end do ! k
	do i=1,nx
	do j=1,ny
	p1(i,j,1)=p1(i,j,2)
	p1(i,j,nz)=p1(i,j,nz1)
	end do ! j
	end do ! i
	delp=0.
	do k=1,nz
	do i=1,nx
	do j=1,ny
	delta=abs(p1(i,j,k)-p(i,j,k))
	delp=amax1(delp,delta)
	p(i,j,k)=p1(i,j,k)
	end do
	end do
	end do
	iter=iter+1
	delp=delp
	if(iter.eq.2) write (*,*)
	write (*,'(1h+,2i8,2e12.4)') iter,itbcong,delp,delp/ds
	if(delp/ds.ge.eps.and.iter.le.niter.or.iter.le.100) go to 1
	write (*,*)
 	vabsmax=1.e-20
	do k=2,nz1
 	do j=1,ny1
	do i=1,nx1
	relk=perm/mu(i,j,k)
	if(i.eq.1) then
	vx(i,j,k)=0.
	else
	vx(i,j,k)=-relk*(p(i+1,j,k)-p(i-1,j,k))/(x(i+1)-x(i-1))
	end if
  	if(j.eq.1) then
	vy(i,j,k)=0.
	else
	vy(i,j,k)=-relk*(p(i,j+1,k)-p(i,j-1,k))/(y(j+1)-y(j-1))
	end if
	vz(i,j,k)=-relk*((p(i,j,k+1)-p(i,j,k-1))/2./dz+
	+(rho(i,j,k)-rgbas(k))*g)
	vabs2=vx(i,j,k)**2+vy(i,j,k)**2+vz(i,j,k)**2
 	vabsmax=amax1(vabsmax,vabs2)
 	end do
	end do
 	end do
	vabsmax=sqrt(vabsmax)
100	 continue

c START OF HEAT TRANSFER
	call heat_gen(time,omega)
	if(iout.eq.1.and.ntime.eq.1) write (3,*) time,t(1,1,nzm),omega
	do k=2,nz1
	do j=1,ny1
	do i=1,nx1
	rfcf=rho(i,j,k)*cf
	nc1=dt/(rfcf*phi+rhocr*phi1)
	nc=rfcf*nc1
 	nlam=cond*nc1
 	if(i.ne.1) then
	vc=vx(i,j,k)/2.
	vabs=abs(vc)
	vxp=vc+vabs
	vxm=vc-vabs
	nlamc=nlam/(x(i+1)-x(i-1))
	alx=(nc*vxm/2.-nlamc)/(x(i+1)-x(i))
	gax=(-nc*vxp/2.-nlamc)/(x(i)-x(i-1))
	else
	gax=0.
	alx=-nlam/(x(2)-x(1))**2
	end if
	bex=1.-alx-gax
	if(j.ne.1) then
	vc=vy(i,j,k)/2.
	vabs=abs(vc)
	vyp=vc+vabs
	vym=vc-vabs
 	nlamc=2.*nlam/(y(j+1)-y(j-1))
	aly=(nc*vym-nlamc)/(y(j+1)-y(j))
	gay=(-nc*vyp-nlamc)/(y(j)-y(j-1))
	else
	gay=0.
	aly=-2.*nlam/(y(2)-y(1))**2
	end if
	bey=-aly-gay
	vc=vz(i,j,k)/2.
	vabs=abs(vc)
	vzp=vc+vabs
	vzm=vc-vabs
	nlamc=nlam/dz
	alz=(nc*vzm-nlamc)/dz
	gaz=(-nc*vzp-nlamc)/dz
	bez=-alz-gaz
	al(i)=alx
	be(i)=bex
	ga(i)=gax
	ww(i)=(2.-bex)*t(i,j,k)-alx*t(i+1,j,k)-gax*t(i-1,j,k)-
     -aly*t(i,j+1,k)-bey*t(i,j,k)-gay*t(i,j-1,k)-
	-alz*t(i,j,k+1)-bez*t(i,j,k)-gaz*t(i,j,k-1)
	if(k.ge.nzb.and.k.le.nzt) then
      ww(i)=ww(i)+omega*womega(i,j)*nc1
	end if
	end do ! i
	al(nx)=0.
	be(nx)=1.
	ga(nx)=0.
	ww(nx)=tbas(k)
	call jakobi(nx,al,be,ga,ww,line)
	do i=1,nx
	t1(i,j,k)=line(i)
	end do
	end do ! j
	end do ! k
	do i=1,nx
	do j=1,ny
	t1(i,j,1)=tbas(1)
	t1(i,j,nz)=tbas(nz)
	end do ! j
	end do ! i
	do i=1,nx
	do k=1,nz
	t1(i,ny,k)=tbas(k)
	end do ! k
	end do ! i
c                        ****	step_y *****
	do k=2,nz1
	do i=1,nx1
	do j=1,ny1
	rfcf=rho(i,j,k)*cf
	nc1=dt/(rfcf*phi+rhocr*phi1)
	nc=rfcf*nc1
	nlam=cond*nc1
	if(i.eq.1) then
	gax=0.
	alx=-nlam/(x(2)-x(1))**2
	else
	vc=vx(i,j,k)/2.
	vabs=abs(vc)
	vxp=vc+vabs
	vxm=vc-vabs
	nlamc=nlam/(x(i+1)-x(i-1))
	alx=(nc*vxm/2.-nlamc)/(x(i+1)-x(i))
	gax=(-nc*vxp/2.-nlamc)/(x(i)-x(i-1))
	end if
	bex=-alx-gax
	if(j.eq.1) then
	gay=0.
	aly=-nlam/(y(2)-y(1))**2
	else
	vc=vy(i,j,k)/2.
	vabs=abs(vc)
	vyp=vc+vabs
	vym=vc-vabs
	nlamc=nlam/(y(j+1)-y(j-1))
	aly=(nc*vym/2.-nlamc)/(y(j+1)-y(j))
	gay=(-nc*vyp/2.-nlamc)/(y(j)-y(j-1))
	end if
	bey=1.-aly-gay
	vc=vz(i,j,k)/2.
	vabs=abs(vc)
	vzp=vc+vabs
	vxm=vc-vabs
	nlamc=nlam/dz
	alz=(nc*vzm-nlamc)/dz
	gaz=(-nc*vzp-nlamc)/dz
	bez=-alz-gaz
	al(j)=aly
	ga(j)=gay
	be(j)=bey
	ww(j)=(2.-bey)*t(i,j,k)-aly*t(i,j+1,k)-gay*t(i,j-1,k)-
     -alx*(t(i+1,j,k)+t1(i+1,j,k))-bex*(t(i,j,k)+t1(i,j,k))-
     -gax*(t(i-1,j,k)+t1(i-1,j,k))-
	-alz*t(i,j,k+1)-bez*t(i,j,k)-gaz*t(i,j,k-1)
	if(k.ge.nzb.and.k.le.nzt) then
      ww(j)=ww(j)+omega*womega(i,j)*nc1
	end if
	end do ! j
	al(ny)=0.
	be(ny)=1.
	ga(ny)=0.
	ww(ny)=tbas(k)
	call jakobi(ny,al,be,ga,ww,line)
	do j=1,ny
	t2(i,j,k)=line(j)
	end do
	end do ! i
	end do ! k
	do i=1,nx
	do j=1,ny
	t2(i,j,1)=tbas(1)
	t2(i,j,nz)=tbas(nz)
	end do
	end do
	do k=1,nz
	do j=1,ny
	t2(nx,j,k)=tbas(k)
	end do
	end do
c	                              ***** step_z *****
	do i=1,nx1
	do j=1,ny1
	do k=2,nz1
	rfcf=rho(i,j,k)*cf
	nc1=dt/(rfcf*phi+rhocr*phi1)
	nc=rfcf*nc1
	nlam=cond*nc1
	if(i.eq.1) then
	gax=0.
	alx=-nlam/(x(2)-x(1))**2
	else
	vc=vx(i,j,k)/2.
	vabs=abs(vc)
	vxp=vc+vabs
	vxm=vc-vabs
	nlamc=nlam/(x(i+1)-x(i-1))
	alx=(nc*vxm/2.-nlamc)/(x(i+1)-x(i))
	gax=(-nc*vxp/2.-nlamc)/(x(i)-x(i-1))
	end if
	bex=-alx-gax
	if(j.eq.1) then
	gay=0.
	aly=-nlam/(y(2)-y(1))**2
	else
	vc=vy(i,j,k)/2.
	vabs=abs(vc)
	vyp=vc+vabs
	vym=vc-vabs
	nlamc=nlam/(y(j+1)-y(j-1))
	aly=(nc*vym/2.-nlamc)/(y(j+1)-y(j))
	gay=(-nc*vyp/2.-nlamc)/(y(j)-y(j-1))
	end if
	bey=-aly-gay
	vc=vz(i,j,k)/2.
	vabs=abs(vc)
	vzp=vc+vabs
	vxm=vc-vabs
	nlamc=nlam/dz
	alz=(nc*vzm-nlamc)/dz/2.
	gaz=(-nc*vzp-nlamc)/dz/2.
	bez=1.-alz-gaz
	al(k)=alz
	be(k)=bez
	ga(k)=gaz
	ww(k)=(2.-bez)*t(i,j,k)-alz*t(i,j,k+1)-gaz*t(i,j,k-1)-
     -alx*(t(i+1,j,k)+t1(i+1,j,k))-bex*(t(i,j,k)+t1(i,j,k))-
	-gax*(t(i-1,j,k)+t1(i-1,j,k))-
	-aly*(t(i,j+1,k)+t2(i,j+1,k))-bey*(t(i,j,k)+t2(i,j,k))-
	-gay*(t(i,j-1,k)+t2(i,j-1,k))
	if(k.ge.nzb.and.k.le.nzt) then
      ww(k)=ww(k)+omega*womega(i,j)*nc1
	end if
	end do ! k
	al(1)=0.
	be(1)=1.
	ga(1)=0.
	ww(1)=tbas(1)
	al(nz)=0.
	be(nz)=1.
	ga(nz)=0.
	ww(nz)=tbas(nz)
	call jakobi(nz,al,be,ga,ww,line)
	do k=1,nz
	t3(i,j,k)=line(k)
	end do
	end do ! j
	end do ! i
	do j=1,ny
	do k=1,nz
	t3(nx,j,k)=tbas(k)
	end do
	end do
	do i=1,nx
	do k=1,nz
	t3(i,ny,k)=tbas(k)
	end do
	end do
	tmax=0.
	do i=1,nx
	do j=1,ny
	do k=1,nz
	t(i,j,k)=t3(i,j,k)
	tmax=amax1(tmax,t(i,j,k))
	end do ! k
	end do ! j
	end do ! i
	write (*,'(6h+time: ,f8.1,f10.1)') time
	write (3,*) time,t(1,1,nzm),omega
	xiphi=xi*phi
	xidz=xi*dz
	vmax=0.
	dismax=0.
	do k=2,nz1
	do j=1,ny1
	do i=1,nx1
	v=sqrt(vx(i,j,k)**2+vy(i,j,k)**2+vz(i,j,k)**2)
	vmax=amax1(vmax,v)
	dispc=diffmol+alphae*v
	dismax=amax1(dismax,dispc)
	dispx(i,j,k)=dispc
	dispy(i,j,k)=dispc
	dispz(i,j,k)=dispc
	end do ! i
	dispx(nx,j,k)=dispx(nx1,j,k)
	dispy(nx,j,k)=dispy(nx1,j,k)
	dispz(nx,j,k)=dispz(nx1,j,k)
	end do ! j
	do i=1,nx
	dispx(i,ny,k)=dispx(i,ny1,k)
	dispy(i,ny,k)=dispy(i,ny1,k)
	dispz(i,ny,k)=dispz(i,ny1,k)
	end do ! i
	end do ! k
	do i=1,nx
	do j=1,ny
	dispx(i,j,nz)=dispx(i,j,nz1)
	dispx(i,j,1)=dispx(i,j,2)
	dispy(i,j,nz)=dispy(i,j,nz1)
	dispy(i,j,1)=dispy(i,j,2)
	dispz(i,j,nz)=dispz(i,j,nz1)
	dispz(i,j,1)=dispz(i,j,2)
	end do ! j
	end do ! i
	uxmax=0.
	uymax=0.
	uzmax=0.
	do i=2,nx1
	do j=2,ny1
	do k=2,nz1
	ux1=dismax*(w(i+1,j,k)-w(i-1,j,k))/(x(i+1)-x(i-1))
	uy1=dismax*(w(i,j+1,k)-w(i,j-1,k))/(y(j+1)-x(j-1))
	uz1=dismax*(w(i,j,k+1)-w(i,j,k-1))/2./dz
	uxmax=amax1(uxmax,abs(ux1))
	uymax=amax1(uymax,abs(uy1))
	uzmax=amax1(uzmax,abs(uz1))
	end do
	end do
	end do

C*******************      MASS TRANSFER      *********************************
	do ntime1=1,intw
	time=time+dtyear1
	t3=w
	t2=w
	iter=0
501	wa=t3
	iter=iter+1
	do i=1,nx
	do j=1,ny
	do k=1,nz
	t2(i,j,k)=t2(i,j,k)*witer+t3(i,j,k)*witer1
	end do ! k
	end do ! j
	end do ! i
	t2=0.
	do i=1,nx1
	do j=1,ny1
	do k=2,nz1
	if(i.eq.1) then
	ux(i,j,k)=0.
	else
	ux(i,j,k)=vx(i,j,k)/xiphi-
	-dispx(i,j,k)*(t2(i+1,j,k)-t2(i-1,j,k))/(x(i+1)-x(i-1))/xi
	end if
	if(j.eq.1) then
	uy(i,j,k)=0.
	else
	uy(i,j,k)=vy(i,j,k)/xiphi-
	-dispy(i,j,k)*(t2(i,j+1,k)-t2(i,j-1,k))/(y(j+1)-y(j-1))/xi
	end if
	uz(i,j,k)=vz(i,j,k)/xiphi-
	-dispz(i,j,k)*(t2(i,j,k+1)-t2(i,j,k-1))/dz/2./xi
	end do
	end do
	end do

c***********************************Step x ****************************
	al(nx)=0.
	be(nx)=1.
	ga(nx)=0.
	ww(nx)=0.
	do k=2,nz1
	do j=1,ny1
	do i=1,nx1
	if(i.eq.1) then
	gax=0.
	disp=(dispx(i+1,j,k)*rho(i+1,j,k)/rho(i,j,k)+dispx(i,j,k))/2.
	alx=-dt1/xi*disp/(x(2)-x(1))**2
	else
	uc=ux(i,j,k)/2.
	uabs=abs(uc)
	up=uc+uabs
	um=uc-uabs
	disp=dispx(i+1,j,k)*rho(i+1,j,k)/rho(i,j,k)+dispx(i,j,k)
	dism=dispx(i-1,j,k)*rho(i-1,j,k)/rho(i,j,k)+dispx(i,j,k)
	alx=dt1/2.*(um-disp/xi/(x(i+1)-x(i-1)))/(x(i+1)-x(i))
	gax=dt1/2.*(-up-dism/xi/(x(i+1)-x(i-1)))/(x(i)-x(i-1))
	end if
	bex=1.-alx-gax
	if(j.eq.1) then
	gay=0.
	disp=dispy(i,j+1,k)*rho(i,j+1,k)/rho(i,j,k)+dispy(i,j,k)
	aly=-dt1/xi*disp/(y(2)-y(1))**2
	else
	disp=dispy(i,j+1,k)*rho(i,j+1,k)/rho(i,j,k)+dispy(i,j,k)
	dism=dispy(i,j-1,k)*rho(i,j-1,k)/rho(i,j,k)+dispy(i,j,k)
	uc=uy(i,j,k)/2.
	uabs=abs(uc)
	up=uc+uabs
	um=uc-uabs
	aly=dt1*(um-disp/xi/(y(j+1)-y(j-1)))/(y(j+1)-y(j))
	gay=dt1*(-up-dism/xi/(y(j+1)-y(j-1)))/(y(j)-y(j-1))
	end if
	bey=-aly-gay
	uc=uz(i,j,k)/2.
	uabs=abs(uc)
	up=uc+uabs
	um=uc-uabs
	disp=(dispz(i,j,k+1)*rho(i,j,k+1)/rho(i,j,k)+dispz(i,j,k))/2.
	dism=(dispz(i,j,k-1)*rho(i,j,k-1)/rho(i,j,k)+dispz(i,j,k))/2.
	alz=dt1/dz*(um-disp/xi/dz)
	gaz=dt1/dz*(-up-dism/xi/dz)
	bez=-alz-gaz
	al(i)=alx
	be(i)=bex
	ga(i)=gax
	ww(i)=-alx*w(i+1,j,k)+(2.-bex)*w(i,j,k)-
	-aly*w(i,j+1,k)-bey*w(i,j,k)-
	-alz*w(i,j,k+1)-bez*w(i,j,k)-gaz*w(i,j,k-1)
	if(i.ne.1) ww(i)=ww(i)-gax*w(i-1,j,k)
	if(j.ne.1) ww(i)=ww(i)-gay*w(i,j-1,k)
	if(k.ge.nzb.and.k.le.nzt) then
	numwell=wnum(i,j)
	call leaching(time,time+dtyear1,t(i,j,k),rho(i,j,k),k,gw)
	add=womega(i,j)*gw*exp(-w(i,j,k))*dt1
	ww(i)=ww(i)+add*(1.+w(i,j,k))
	be(i)=be(i)+add
	end if
	end do ! i
	call jakobi(nx,al,be,ga,ww,line)
	do i=1,nx
	t1(i,j,k)=line(i)
	end do ! i
	end do ! j
	end do ! k

	do i=1,nx
	do k=2,nz1
	t1(i,ny,k)=0.
	end do
	end do
	do i=1,nx
	do j=1,ny
	t1(i,j,nz)=t1(i,j,nz1)
	t1(i,j,1)=0.
	end do ! j
	end do ! i

c***********************************Step y****************************
	al(ny)=0.
	be(ny)=1.
	ga(ny)=0.
	ww(ny)=0.
	do k=2,nz1
	do i=1,nx1
	do j=1,ny1
	if(i.eq.1) then
	gax=0.
	disp=(dispx(i+1,j,k)*rho(i+1,j,k)/rho(i,j,k)+dispx(i,j,k))/2.
	alx=-dt1/xi*disp/(x(2)-x(1))**2
	else
	uc=ux(i,j,k)/2.
	uabs=abs(uc)
	up=uc+uabs
	um=uc-uabs
	disp=dispx(i+1,j,k)*rho(i+1,j,k)/rho(i,j,k)+dispx(i,j,k)
	dism=dispx(i-1,j,k)*rho(i-1,j,k)/rho(i,j,k)+dispx(i,j,k)
	alx=dt1/2.*(um-disp/xi/(x(i+1)-x(i-1)))/(x(i+1)-x(i))
	gax=dt1/2.*(-up-dism/xi/(x(i+1)-x(i-1)))/(x(i)-x(i-1))
	end if
	bex=-alx-gax
	if(j.eq.1) then
	gay=0.
	disp=dispy(i,j+1,k)*rho(i,j+1,k)/rho(i,j,k)+dispy(i,j,k)
	aly=-dt1/xi*disp/(y(2)-y(1))**2/2.
	else
	disp=dispy(i,j+1,k)*rho(i,j+1,k)/rho(i,j,k)+dispy(i,j,k)
	dism=dispy(i,j-1,k)*rho(i,j-1,k)/rho(i,j,k)+dispy(i,j,k)
	uc=uy(i,j,k)/2.
	uabs=abs(uc)
	up=uc+uabs
	um=uc-uabs
	aly=dt1*(um-disp/xi/(y(j+1)-y(j-1)))/(y(j+1)-y(j))/2.
	gay=dt1*(-up-dism/xi/(y(j+1)-y(j-1)))/(y(j)-y(j-1))/2.
	end if
	bey=1.-aly-gay
	uc=uz(i,j,k)/2.
	uabs=abs(uc)
	up=uc+uabs
	um=uc-uabs
	disp=(dispz(i,j,k+1)*rho(i,j,k+1)/rho(i,j,k)+dispz(i,j,k))/2.
	dism=(dispz(i,j,k-1)*rho(i,j,k-1)/rho(i,j,k)+dispz(i,j,k))/2.
	alz=dt1/dz*(um-disp/xi/dz)
	gaz=dt1/dz*(-up-dism/xi/dz)
	bez=-alz-gaz
	al(j)=aly
	be(j)=bey
	ga(j)=gay
	ww(j)=-alx*(w(i+1,j,k)+t1(i+1,j,k))-bex*(w(i,j,k)+t1(i,j,k))-
	-aly*w(i,j+1,k)+(2.-bey)*w(i,j,k)-
	-alz*w(i,j,k+1)-bez*w(i,j,k)-gaz*w(i,j,k-1)
	if(i.ne.1) ww(j)=ww(j)-gax*(w(i-1,j,k)+t1(i-1,j,k))
	if(j.ne.1) ww(j)=ww(j)-gay*w(i,j-1,k)
	if(k.ge.nzb.and.k.le.nzt) then
	numwell=wnum(i,j)
	call leaching(time,time+dtyear1,t(i,j,k),rho(i,j,k),k,gw)
	add=womega(i,j)*gw*exp(-w(i,j,k))*dt1
	ww(j)=ww(j)+add*(1.+w(i,j,k))
	be(j)=be(j)+add
	end if
	end do ! j
	call jakobi(ny,al,be,ga,ww,line)
	do j=1,ny
	t2(i,j,k)=line(j)
	end do ! j
	end do ! i
	end do ! k
	do j=1,ny
	do k=2,nz1
	t2(nx,j,k)=0.
	end do
 	end do
	do i=1,nx
	do j=1,ny
	t2(i,j,nz)=t2(i,j,nz1)
	t2(i,j,1)=0.
	end do ! j
	end do ! i

c *************************************Stepz  *********************************
	al(nz)=0.
	be(nz)=1.
	ga(nz)=-1.
	ww(ny)=0.
	al(1)=0.
	be(1)=1.
	ga(1)=0.
	ww(1)=0.
	do i=1,nx1
	do j=1,ny1
	do k=2,nz1
	if(i.eq.1) then
	gax=0.
	disp=(dispx(i+1,j,k)*rho(i+1,j,k)/rho(i,j,k)+dispx(i,j,k))/2.
	alx=-dt1/xi*disp/(x(2)-x(1))**2
	else
	uc=ux(i,j,k)/2.
	uabs=abs(uc)
	up=uc+uabs
	um=uc-uabs
	disp=dispx(i+1,j,k)*rho(i+1,j,k)/rho(i,j,k)+dispx(i,j,k)
	dism=dispx(i-1,j,k)*rho(i-1,j,k)/rho(i,j,k)+dispx(i,j,k)
	alx=dt1/2.*(um-disp/xi/(x(i+1)-x(i-1)))/(x(i+1)-x(i))
	gax=dt1/2.*(-up-dism/xi/(x(i+1)-x(i-1)))/(x(i)-x(i-1))
	end if
	bex=-alx-gax
	if(j.eq.1) then
	gay=0.
	disp=dispy(i,j+1,k)*rho(i,j+1,k)/rho(i,j,k)+dispy(i,j,k)
	aly=-dt1/xi*disp/(y(2)-y(1))**2/2.
	else
	disp=dispy(i,j+1,k)*rho(i,j+1,k)/rho(i,j,k)+dispy(i,j,k)
	dism=dispy(i,j-1,k)*rho(i,j-1,k)/rho(i,j,k)+dispy(i,j,k)
	uc=uy(i,j,k)/2.
	uabs=abs(uc)
	up=uc+uabs
	um=uc-uabs
	aly=dt1*(um-disp/xi/(y(j+1)-y(j-1)))/(y(j+1)-y(j))/2.
	gay=dt1*(-up-dism/xi/(y(j+1)-y(j-1)))/(y(j)-y(j-1))/2.
	end if
	bey=-aly-gay
	uc=uz(i,j,k)/2.
	uabs=abs(uc)
	up=uc+uabs
	um=uc-uabs
	disp=(dispz(i,j,k+1)*rho(i,j,k+1)/rho(i,j,k)+dispz(i,j,k))/2.
	dism=(dispz(i,j,k-1)*rho(i,j,k-1)/rho(i,j,k)+dispz(i,j,k))/2.
	alz=dt1/dz*(um-disp/xi/dz)/2.
	gaz=dt1/dz*(-up-dism/xi/dz)/2.
	bez=1.-alz-gaz
	al(k)=alz
	be(k)=bez
	ga(k)=gaz
	ww(k)=-alx*(w(i+1,j,k)+t1(i+1,j,k))-bex*(w(i,j,k)+t1(i,j,k))-
	-aly*(w(i,j+1,k)+t2(i,j+1,k))-bey*(w(i,j,k)+t2(i,j,k))-
	-alz*w(i,j,k+1)+(2.-bez)*w(i,j,k)-gaz*w(i,j,k-1)
	if(i.ne.1) ww(k)=ww(k)-gax*(w(i-1,j,k)+t1(i-1,j,k))
	if(j.ne.1) ww(k)=ww(k)-gay*(w(i,j-1,k)+t2(i,j-1,k))
	if(k.ge.nzb.and.k.le.nzt) then
	numwell=wnum(i,j)
	call leaching(time,time+dtyear1,t(i,j,k),rho(i,j,k),k,gw)
	add=womega(i,j)*gw*exp(-w(i,j,k))*dt1
	ww(k)=ww(k)+add*(1.+w(i,j,k))
	be(k)=be(k)+add
	end if
	end do ! k
	call jakobi(nz,al,be,ga,ww,line)
	do k=1,nz
	t3(i,j,k)=line(k)
	end do ! k
	end do ! i
	end do ! j
	do j=1,ny
	do k=1,nz
	t3(nx,j,k)=0.
	end do
	end do
	do i=1,nx
	do k=1,nz
	t3(i,ny,k)=0.
	end do ! k
	end do ! i
	delw=0.
	wmax=0.
	do i=1,nx
	do j=1,ny
	do k=1,nz
	delc=t3(i,j,k)-wa(i,j,k)
	delw=amax1(delw,abs(delc))
	wmax=amax1(wmax,abs(t3(i,j,k)))
	end do
	end do
	end do
	if(delw.gt.0.01*wmax) go to 501
	do i=1,nx
	do j=1,ny
	do k=1,nz
	w(i,j,k)=amax1(0.,t3(i,j,k))
	end do ! k
	end do ! j
	end do ! i
300	continue
	end do ! ntime1
	end do ! n
200	continue
	t3max=t(1,1,nzm)
	t3min=t(1,1,nzm)
	do i=1,nx
	do j=1,ny
	t3max=amax1(t3max,t(i,j,nzm))
	t3min=amin1(t3min,t(i,j,nzm))
	end do
	end do
	write (symb,'(i2)') iout
	tgrd(2:3)=symb
	tprofile(9:10)=symb
	velocity(6:7)=symb
	pressure(6:7)=symb
	open (1,file=tgrd)
	write (1,30) xlimgrid,ylimgrid,t3min,t3max
	do j=1,101
	j1=jgrid(j)
	do i=1,101
	i1=igrid(i)
	tc1=t(i1,j1,nzm)*(1.-rxgrd(i))+t(i1+1,j1,nzm)*rxgrd(i)
	tc2=t(i1,j1+1,nzm)*(1.-rxgrd(i))+t(i1+1,j1+1,nzm)*rxgrd(i)
	line(i)=tc1*(1.-rygrd(j))+tc2*rygrd(j)
	end do ! i
	write (1,'(7e11.4)') line
	end do ! j
	t3max=w(1,1,nzm)
	t3min=w(1,1,nzm)
	do i=1,nx
	do k=1,nz
	t3max=amax1(t3max,w(i,1,k))
	t3min=amin1(t3min,w(i,1,k))
	end do
	end do
	cgrd(2:3)=symb
	open (1,file=cgrd)
	write (1,31) nz,xlimgrid,zlim,t3min,t3max
30	format ('DSAA'/'101 101'/2('0. ',f10.1/),2e11.4)
31	format ('DSAA'/'101 ',i3/2('0. ',f10.1/),2e11.4)
	do k=1,nz
	do i=1,101
	i1=igrid(i)
	line(i)=w(i1,1,k)*(1.-rxgrd(i))+w(i1+1,1,k)*rxgrd(i)
	end do ! i
	write (1,'(7e11.4)') line
	end do ! k
 	t3max=w(1,1,nzm)
 	t3min=w(1,1,nzm)
	do i=1,nx
	do j=1,ny
	wc=w(i,j,nzm)
	if(wc.lt.t3min) then
	t3min=wc
	imin=i
	jmin=j
	end if
	if(wc.gt.t3max) then
	imax=i
	jmax=j
	t3max=wc
	end if
	end do
	end do
	wgrd(2:3)=symb
	open (1,file=wgrd)
	write (1,30) xlimgrid,ylimgrid,t3min,t3max
	do j=1,101
	j1=jgrid(j)
	do i=1,101
	i1=igrid(i)
	tc1=w(i1,j1,nzm)*(1.-rxgrd(i))+w(i1+1,j1,nzm)*rxgrd(i)
	tc2=w(i1,j1+1,nzm)*(1.-rxgrd(i))+w(i1+1,j1+1,nzm)*rxgrd(i)
	line(i)=tc1*(1.-rygrd(j))+tc2*rygrd(j)
	end do ! i
	write (1,'(7e11.4)') line
	end do ! j
	open (1,file=tprofile)
	do i=1,nx
	write (1,*) x(i),t(i,1,nzm)
	end do ! i
	open (1,file='pressure')
	pmin=p(1,1,1)
	pmax=p(1,1,1)
	do i=1,nx
	do k=1,nz
	pc=p(i,1,k)
	pmin=amin1(pmin,pc)
	pmax=amax1(pmax,pc)
	end do
	end do
	open (1,file='press.grd')
	write (1,40) xlimgrid,ylimgrid,pmin,pmax
	do k=1,41
	do i=1,101
	i1=igrid(i)
	line(i)=p(i1,1,k)*(1.-rxgrd(i))+p(i1+1,1,k)*rxgrd(i)
	end do ! i
	write (1,'(7e11.4)') line
	end do ! j
40	format ('DSAA'/'101 41'/2('0. ',f10.1/),2e11.4)
201	CONTINUE
 	open (1,file=velocity)
 	do i=1,nx1
	do k=2,nz1
	vabs=sqrt(vx(i,1,k)**2+vz(i,1,k)**2)
	if(vabs.ge.1.e-5*vabsmax) then
	angle=atan2(vz(i,1,k),vx(i,1,k))
	write (1,'(1x,3f10.3,5e12.4)') x(i),dz*(k-1),
	*angle*57.3-90.,vabs/vabsmax,vx(i,1,k),vz(i,1,k)
	end if
	end do
	end do
	close (1)
	end do ! iout
	end


 	 subroutine tabgener(t1,t2,p1,p2)
 	common /tables/t0,p0,dt,dp,tabd(51,51),tabv(51,51)
	dt=(t2-t1)/50.
	dp=(p2-p1)/50.
	t0=t1
	p0=p1
	do i=1,51
	p=p0+dp*(i-1)
	do j=1,51
	t=t0+dt*(j-1)
	r=rho(p,t)
	tabd(i,j)=r
	tabv(i,j)=cmu(r,t)
	end do
	end do
	return
	end

	function rho(p,t)
	real d(20)
	data pc/221.2e5/,tc/647.3/,rc/315.46/
	rho=1.
	tabs=t+273.15
	if(tabs.lt.tc) then
	psat=satpress(t)
	if(p.le.psat) then
	p1=psat
	else
	p1=p
	e=tabs/tc
	d(1)=e
	do i=2,20
	d(i)=d(i-1)*e
 	end do
	b=p1/pc
	b2=b*b
	b3=b2*b
	y=1.-0.84384*d(2)-5.3622e-4/d(6)
	z=y+sqrt(1.72*y*y-0.146846*e+0.099518*b)
	a=0.39721/z**0.29412-0.026166+1.5224e-3*e+2.2843e-2*d(2)+
     +	242.16*(0.65372-e)**10+1.2697e-10/(1.15e-6+d(19))-
     -  (2.0748e-7+4.348e-8*b+3.3171e-9*b2)/(1.5108e-5+d(11))-
     -  12.934*d(18)*(0.14188+d(2))*(2.9953e-4-3./(7.00275+b)**4)+
     +  3.9243e-5*(0.204-e)*b2+24.1904e-14*b3/d(20)-
     -  10.3746e-5*b2*d(19)
        rho=rc/a
	end if
	end if
        return
        end

	function satpress(tcels)
	real*8 sum
	T=273.15+tcels
	sum=-5.8002206d3/T+1.3914993d0-4.8640239d-2*T+
	+4.1764768d-5*T**2-1.4452093d-8*T**3+6.54596*alog(T)
	satpress=dexp(sum)
	return
	end


        function cmu(rho,t)
        dimension r(7),num(6)
        real*8 sum,sum1,a(7,6)
        data a/0.5132047,0.2151778,-0.2818107,0.1778064,-0.0417661,2*0.,
     *  0.3205656,0.7317883,-1.070786,0.460504,0.,-0.01578386,0.,
     *  0.,1.241044,-1.263184,0.2340379,3*0.,
     *  0.,1.476783,0.,-0.4924179,0.1600435,0.,-0.003629481,
     *  -0.7782567,6*0.,0.1885447,6*0./,num/5,6,4,7,1,1/
        rr=rho/317.763
        tr=(t+273.15)/647.27
        t2=tr*tr
        t3=t2*tr
        r(1)=1.
        r(2)=rr-1.
        do i=3,7
        r(i)=r(i-1)*r(2)
        end do
        d=1./tr-1.
        term=1.
        sum=0.
        do i=1,6
        sum1=0.
        do j=1,num(i)
        sum1=sum1+a(j,i)*r(j)
        end do
        sum=sum+sum1*term
        term=term*d
        end do
        e1=exp(rr*sum)
        e=1.e-6*sqrt(tr)/
     /  (0.0181583+0.0177624/tr+0.0105287/t2-0.0036744/t3)
       	cmu=e*e1
        return
        end
        
	  subroutine prop(p,t,r,index)
	common /tables/t0,p0,dt,dp,tabd(51,51),tabv(51,51)
        real x(2)
        character*4 index

        rt=(t-t0)/dt
        rp=(p-p0)/dp
        rt=amin1(50.,amax1(rt,0.))
        rp=amin1(50.,amax1(rp,0.))
        j=rt
        rt=rt-j
        i=rp
        rp=rp-i
        j=j+1
        i=i+1
        if(rt.lt.0.) then
        j=j-1
        rt=1.+rt
        end if
   	 	if(rp.lt.0.) then
        i=i-1
        rp=1.+rp
        end if
        rt1=1.-rt


        do l=1,2
        if(index.eq.'dens') then
        x(l)=tabd(i+l-1,j)*rt1+tabd(i+l-1,j+1)*rt
        else
        x(l)=tabv(i+l-1,j)*rt1+tabv(i+l-1,j+1)*rt
        end if
        end do
        r=x(1)*(1.-rp)+x(2)*rp
        return
        end

		subroutine root(n,c,g)
		f(x)=(x**n-1.)/(x-1.)-c
		g1=1.0001
		do i=1,10000
		g2=g1+0.1*(i-1)
		f2=f(g2)
		if(f2.gt.0.) go to 1
		end do
1		g=(g1+g2)/2.
		fg=f(g)
		if(fg.lt.0.) then
		g1=g
		else
		g2=g
		end if
		if(g2-g1.gt.0.00001) go to 1
		g=(g1+g2)/2.
		return
		end


      SUBROUTINE JAKOBI(N,A,B,G,W,T)
	REAL*8 A(101),B(101),G(101),W(101),X(101),Y(101),R
			real T(101)

      X(N-1)=-G(N)/B(N)
      Y(N-1)=W(N)/B(N)
      LIM=N-2
      DO 1 I=1,LIM
      K=LIM-I+1
      J=K+1
      R=A(J)*X(J)+B(J)
      X(K)=-G(J)/R
1     Y(K)=(W(J)-A(J)*Y(J))/R
      T(1)=(W(1)-A(1)*Y(1))/(B(1)+A(1)*X(1))
      DO 2 I=2,N
      J=I-1
2     T(I)=T(J)*X(J)+Y(J)
      RETURN
      END

    
       subroutine mult(u,w,feature)
	  integer feature
        real*8 an(10201),as(10201),ae(10201),aw(10201),ap(10201)
        real*8 u(10201),w(10201),s
        common /matr/ap,an,ae,aw,as/mesh/nx,ny,nxy
        do i=1,nx
        do j=1,ny
         k=i+(j-1)*nx
         s=ap(k)*u(k)
 		if(feature.eq.1) then
         if(i.gt.1) s=s+aw(k)*u(k-1)
        if(i.lt.nx) s=s+ae(k)*u(k+1)
        if(j.gt.1) s=s+as(k)*u(k-nx)
        if(j.lt.ny) s=s+an(k)*u(k+nx)
		else
        if(i.gt.1) s=s+ae(k-1)*u(k-1)
         if(i.lt.nx) s=s+aw(k+1)*u(k+1)
        if(j.gt.1) s=s+an(k-nx)*u(k-nx)
        if(j.lt.ny) s=s+as(k+nx)*u(k+nx)
        end if
        w(k)=s
        end do
        end do
        return
        end

		subroutine bcong(u0,u,eps)
        real*8 r1(10201),p1(10201),r2(10201),p2(10201),b(10201)
        real*8 an(10201),as(10201),ae(10201),aw(10201),ap(10201)
		real u(101,101)
        real*8 u0(10201),w(10201),sum,rho,bet,alpha,sigma,umax
        common /matr/ap,an,ae,aw,as/right/b
     *  /mesh/nx,ny,nxy/solver/niter
	common /debug/ iter

	 	delta=1.e10
		umax=0.
        do i=1,nx
		do j=1,ny
		k=i+(j-1)*nx
        u0(k)=u(i,j)
		a=dmax1(dabs(ap(k)),dabs(an(k)),dabs(ae(k)),
     *	dabs(aw(k)),dabs(as(k)))
	 	if(ap(k).le.0.) a=-a
 		ap(k)=ap(k)/a
		an(k)=an(k)/a
		ae(k)=ae(k)/a
		aw(k)=aw(k)/a
		as(k)=as(k)/a
		b(k)=b(k)/a
		end do
			end do
		call mult(u0,w,1)
			do k=1,nxy
 			r1(k)=b(k)-w(k)
			r2(k)=r1(k)
		p1(k)=0.
		p2(k)=0.
			umax=dmax1(umax,dabs(r1(k)))
			end do
			if(umax.le.1.e-10) return
       		rho=1.
		iter=0
		do while (delta.ge.eps*umax.and.iter.le.niter.or.iter.le.100)
		iter=iter+1
			sum=0.
			do k=1,nxy
			sum=sum+r1(k)*r2(k)
			end do
			bet=sum/rho
			rho=sum
			do k=1,nxy
			p1(k)=r1(k)+bet*p1(k)
		p2(k)=r2(k)+bet*p2(k)
        end do
        call mult(p1,w,1)
        sigma=0.
        do k=1,nxy
        sigma=sigma+p2(k)*w(k)
        end do
        alpha=rho/sigma
        do k=1,nxy
        r1(k)=r1(k)-alpha*w(k)
        u0(k)=u0(k)+alpha*p1(k)
	  end do
		call mult(p2,w,2)
		do k=1,nxy
		r2(k)=r2(k)-alpha*w(k)
		end do
        delta=0.
        umax=0.
        do i=1,nx
        do j=1,ny
        k=i+(j-1)*nx
        dp1=dabs(r1(k))
        delta=amax1(delta,dp1)
        du0=dabs(u0(k))
        umax=amax1(umax,du0)
        end do ! j
        end do ! i
        end do ! iter
    	return
        end
 
    	subroutine HEAT_GEN(tyear,Qsum)
	REAL*8 KAPPA(3,2),RHO(3,2),E1,E2,E3
	REAL THL(3,2),Q(3,2)
	REAL WEIGHT(2),RHO0(2),XI(3,2),AW(3,2)	
	common /waste/act,ree,timestor,numrad,numwell,
	*cl1,cl2,f0,rkappa,rhom,wmass(4,41)
	DATA THL /433.,2.14E6,1.59E5,18.1,6537.,2.3E7/
	DATA Q/114.7,0.0207,0.203,2842.,7.,0.0013/
	DATA CKAPPA/2.2E-8/,INDEX/1/,WEIGHT/0.9,0.1/
	DATA AW/241.,237.,233.,244.,240.,236./
	DATA SR90/0.0001/,CS137/0.003/
	IF(INDEX.EQ.1) THEN
	INDEX=2

	ZCS=RHOM*CS137*0.435E3
	ZSR=RHOM*SR90*1.07E3
	SRKAPPA=0.693/28.8
	CSKAPPA=0.693/30.16

	Z=ACT*REE
 	DO J=1,2
	RHO0(J)=Z*RHOM*WEIGHT(J)
	DO I=1,3
	KAPPA(I,J)=CKAPPA/THL(I,J)
	END DO ! I
	XI(1,J)=KAPPA(1,J)*AW(2,J)/AW(1,J)*RHO0(J)
	XI(2,J)=XI(1,J)*KAPPA(2,J)*AW(3,J)/AW(2,J)
	END DO ! J

	f0=weight(numrad)*z
	rkappa=kappa(1,numrad)

	END IF
	T=(TYear+timestor)*3.15E7
	DO J=1,2
	E1=DEXP(-T*KAPPA(1,J))
	E2=DEXP(-T*KAPPA(2,J))
	E3=DEXP(-T*KAPPA(3,J))
	RHO(1,J)=RHO0(J)*E1
	RHO(2,J)=XI(1,J)/(KAPPA(2,J)-KAPPA(1,J))*(E1-E2)
	RHO(3,J)=XI(2,J)/(KAPPA(3,J)-KAPPA(2,J))/
	/(KAPPA(3,J)-KAPPA(1,J))*E3+
	+XI(2,J)/(KAPPA(2,J)-KAPPA(1,J))*
	*(E1/(KAPPA(3,J)-KAPPA(1,J))-E2/(KAPPA(3,J)-KAPPA(2,J)))
	END DO ! J

	QSum=0.
	TYEAR1=TYEAR+TIMESTOR
	QSUM=ZCS*EXP(-CSKAPPA*TYEAR1)+ZSR*EXP(-SRKAPPA*TYEAR1)
	DO J=1,2
	DO I=1,3
	QSum=QSum+RHO(I,J)*Q(I,J)
	END DO
	END DO
	return
	END

	subroutine leaching(time1,time2,therm,rho,k,gw)

	common /waste/act,ree,timestor,numrad,numwell,
	*cl1,cl2,f0,rkappa,rhom,wmass(4,41)

	data c0/0.00275/ ! 1/363
	if(wmass(numwell,k).gt.1.e-5) then
	factor=1./(therm+273.)-c0
	factor=exp(-7765.*factor)
	t1=3.15e7*time1
	t2=3.15e7*time2
	ajint=2.47e-6*(t2**0.43-t1**0.43)*factor
c	wmass(numwell,k)=wmass(numwell,k)-ajint*cl1
	gw=cl2*f0*ajint/rho
	end if
	return
	end




